import csv
import glob
import os
import shutil
from itertools import islice

import pandas as pd

result_directory = 'results'
new_result_directory = 'seq_results'
new_result_filename = 'sequence-test_model_augmentation.csv'

if not os.path.exists(new_result_directory):
    os.makedirs(new_result_directory)

new_result_path = os.path.join(new_result_directory, new_result_filename)

folders_list = glob.glob(f'{result_directory}/*')

print(folders_list)

# newfile = open(new_result_path, 'w', newline='')
# writer = csv.writer(newfile)
# for idx_folder, folder in enumerate(folders_list):
#     sequence_csv = glob.glob(f'{folder}/sequence*.csv')[0]
#     print(sequence_csv)
#     start_from = 1
#     if idx_folder == 0:
#         start_from = 0
#     with open(sequence_csv, 'r') as csvfile:
#         reader = csv.reader(csvfile, delimiter=',')
#         for idx_row, row in enumerate(islice(reader, start_from, None)):
#             writer.writerow(row)
#
# newfile.close()
new_sequence_df = pd.DataFrame()
sequence_df_list = []
for idx_folder, folder in enumerate(folders_list):
    sequence_csv = glob.glob(f'{folder}/sequence*.csv')[0]
    try:
        sequence_df = pd.read_csv(sequence_csv, header=0)
        print(sequence_df)
    except Exception as e:
        print(e)

    # new_sequence_df.append(sequence_df, ignore_index=True)
    sequence_df_list.append(sequence_df)

new_sequence_df = pd.concat(sequence_df_list, ignore_index=True)
print(new_sequence_df)
new_sequence_df.to_csv(f'{new_result_directory}/{new_result_filename}', index=False)

max_iou_idx = new_sequence_df[['best_test_iou']].idxmax()
print(max_iou_idx)
seq_name_max = new_sequence_df.loc[max_iou_idx, 'sequence_name'].values[0]
run_name_max = new_sequence_df.loc[max_iou_idx, 'run_name'].values[0]
print(seq_name_max)
print(run_name_max)

# shutil.copy2('/src/file.ext', '/dst/dir')
source_dir = f'{result_directory}/{seq_name_max}/{run_name_max}'
destination_dir = f'{new_result_directory}/{run_name_max}'
shutil.copytree(source_dir, destination_dir, dirs_exist_ok=True)

shutil.copy2(f'{source_dir}.csv', f'{destination_dir}.csv')
