import csv
from itertools import islice

import numpy as np
from PIL import Image
from matplotlib import pyplot as plt
from tqdm import tqdm


def str_to_image(image_blob):
    ''' Convert a string blob to an image object. '''
    image_string = image_blob.split(' ')
    image_data = np.asarray(image_string, dtype=np.uint8).reshape(48,48)
    return image_data #Image.fromarray(image_data)

file_path = f'facial-expression-dataset/icml_face_data.csv'

plt.figure()
rows = 3
cols = 3
img_idx = 0
index = 1
with open(file_path,'r') as csvfile:
    fer_rows = csv.reader(csvfile, delimiter=',')
    print(fer_rows[0])
    for idx_row, row in tqdm(enumerate(islice(fer_rows, 1, None))):
        image = str_to_image(row[-1])
        print(idx_row, index, image.shape, len(row), row[0], row[1])

        if img_idx > 4:
            continue
        elif index > rows * cols:
            plt.figure()
            index = 1
            img_idx += 1
            # break
        # else:
        plt.subplot(rows, cols, index)
        plt.imshow(image, cmap=plt.get_cmap('gray'))

        index += 1


plt.show()