import matplotlib.pyplot as plt
import numpy as np
import pandas as pd

classes_num = 8
sequence_name = f'emo_{classes_num}classes'

# run_nr = 1

path = f'D:\\EmotionSegmentationData\\results\\{sequence_name}\\sequence-{sequence_name}.csv'

seq_df = pd.read_csv(path)

print(seq_df)

# namelist = ['', '_neutral', '_happiness', '_sadness', '_anger']
namelist = ['', '_neutral','_happiness','_sadness','_anger', '_surprise', '_disgust','_fear','_contempt']

namelist = namelist[:classes_num+1]

cols = [f'best_test_f1_score{m}' for m in namelist]

print(seq_df[cols])

# find best run f1_score
index_best = seq_df[seq_df['best_test_f1_score']==seq_df['best_test_f1_score'].max()].index[0]
print(index_best)

best_run = seq_df.loc[index_best, 'run_name']
best_lr = seq_df.loc[index_best, 'learning_rate']


plt.figure(figsize=(8, 5))
plt.bar([col[10:] for col in cols], seq_df.loc[index_best, cols], width=0.5)
plt.ylabel('F1 score')
plt.xticks(rotation=45)
plt.title(f'{best_run}, learning_rate = {best_lr}')
plt.tight_layout()
plt.savefig(f'f1_plots/f1_{sequence_name}_{index_best+1}-run.png')

# seq_df[cols].plot()
# plt.legend()
plt.show()