import matplotlib.pyplot as plt
import numpy as np
import pandas as pd

classes_num = 4
sequence_name = f'emo_{classes_num}classes'
path_seq = f'D:\\EmotionSegmentationData\\results\\{sequence_name}\\sequence-{sequence_name}.csv'
seq_df = pd.read_csv(path_seq)

# find best run f1_score
index_best = seq_df[seq_df['best_test_f1_score']==seq_df['best_test_f1_score'].max()].index[0]
best_run = seq_df.loc[index_best, 'run_name']
best_lr = seq_df.loc[index_best, 'learning_rate']
print(index_best, best_run, best_lr)


path = f'D:\\EmotionSegmentationData\\results\\{sequence_name}\\{best_run}.csv'

run_df0 = pd.read_csv(path)

min_index = len(run_df0) #run_df0['step'][run_df0['test_loss'].values == run_df0['test_loss'].min()].index[0] + 2
print(min_index)

run_df = run_df0[:min_index]

print(run_df.columns)

plt.figure(figsize=(8, 5))
plts = []
ax1 = plt.subplot(111)
plts += ax1.plot(run_df['step'], run_df['train_loss'], color=f'C0', label='train_loss')
plts += ax1.plot(run_df['step'], run_df['test_loss'], color=f'C1', label='test_loss')
ax1.set_ylabel('loss')
ax2 = plt.twinx(ax1)
plts += ax2.plot(run_df['step'], run_df['train_acc'], color=f'C2', label='train_acc')
plts += ax2.plot(run_df['step'], run_df['test_acc'], color=f'C3', label='test_acc')
ax2.set_ylabel('accuracy')
ax1.set_xlabel('epoch')
plt.title(f'{best_run}, learning_rate={best_lr}')

plt.legend(plts, [it.get_label() for it in plts])

plt.savefig(f'f1_plots/loss_acc_overfit_{sequence_name}_{index_best+1}-run.png')
plt.show()